image: ubuntu:20.04

stages:
  - test
  - deploy
  - build

before_script:
- bash ci/docker_install.sh

test_nc_sqlite:
  stage: test
  only:
    refs:
      - master
      - test
  artifacts:
    paths:
      - coverage
  coverage: '/^\s*Lines:\s*(\d+.\d+)\%/'
  script:
    # copy local copy that has been cloned already
    - cp -r . /tmp/gpxpod
    - mkdir -p /var/www/html ; pushd /var/www/html
    - git clone https://github.com/nextcloud/server.git --recursive --depth 1 -b stable20 nextcloud
    # temporary fix of autoloader.php
    - sed -i $'s|if (substr($fullPath, 0, strlen($root) + 1) === $root . \'/\')|if (is_string($root) and substr($fullPath, 0, strlen($root) + 1) === $root . \'/\')|g' nextcloud/lib/autoloader.php
    - chown -R www-data:www-data nextcloud && pushd nextcloud/apps && mv /tmp/gpxpod ./
    - sudo -u www-data php /var/www/html/nextcloud/occ maintenance:install --database "sqlite" --admin-user "admin" --admin-pass "password"
    - sudo -u www-data php /var/www/html/nextcloud/occ app:enable gpxpod
    - sudo -u www-data php /var/www/html/nextcloud/occ maintenance:mode --off
    # check code with occ
    - sudo -u www-data php /var/www/html/nextcloud/occ app:check-code gpxpod
    # check JS code
    - jshint --verbose gpxpod/js/gpxpod.js && echo "jshint OK" || echo "jshint has complaints"
    - popd ; popd ; mkdir coverage
    - phpunit --configuration /var/www/html/nextcloud/apps/gpxpod/phpunit.xml --coverage-text --color=never --coverage-html coverage

test_nc_pgsql:
  stage: test
  only:
    refs:
      - master
      - test
  services:
      - postgres:latest
  variables:
      POSTGRES_DB: plop
      POSTGRES_USER: postgres
      POSTGRES_PASSWORD: "toto"
  script:
    - DEBIAN_FRONTEND=noninteractive apt-get install php7.4-pgsql postgresql-client -yqq > /dev/null 2>&1
    # copy local copy that has been cloned already
    - cp -r . /tmp/gpxpod
    - mkdir -p /var/www/html ; pushd /var/www/html
    - git clone https://github.com/nextcloud/server.git --recursive --depth 1 -b stable20 nextcloud
    # temporary fix of autoloader.php
    - sed -i $'s|if (substr($fullPath, 0, strlen($root) + 1) === $root . \'/\')|if (is_string($root) and substr($fullPath, 0, strlen($root) + 1) === $root . \'/\')|g' nextcloud/lib/autoloader.php
    - chown -R www-data:www-data nextcloud && pushd nextcloud/apps && mv /tmp/gpxpod ./
    - sudo -u www-data php /var/www/html/nextcloud/occ maintenance:install --database "pgsql" --database-host "postgres:5432" --database-name oc_autotest --database-user postgres --database-pass="toto" --admin-user "admin" --admin-pass "password"
    - sudo -u www-data php /var/www/html/nextcloud/occ app:enable gpxpod
    - sudo -u www-data php /var/www/html/nextcloud/occ maintenance:mode --off
    # check code with occ
    - sudo -u www-data php /var/www/html/nextcloud/occ app:check-code gpxpod
    # check JS code
    - jshint --verbose gpxpod/js/gpxpod.js && echo "jshint OK" || echo "jshint has complaints"
    - popd ; popd ; mkdir coverage
    - phpunit --configuration /var/www/html/nextcloud/apps/gpxpod/phpunit.xml

test_nc_mysql:
  stage: test
  only:
    refs:
      - master
      - test
  script:
    # DB
    - DEBIAN_FRONTEND=noninteractive apt-get install mariadb-server php7.4-mysql -yqq > /dev/null 2>&1
    - service mysql start
    - mysql -u root -e 'create database oc_autotest;'
    - mysql -u root -e "CREATE USER 'oc_autotest'@'localhost' IDENTIFIED BY '';"
    - mysql -u root -e "grant all on oc_autotest.* to 'oc_autotest'@'localhost';"
    # copy local copy that has been cloned already
    - cp -r . /tmp/gpxpod
    - mkdir -p /var/www/html ; pushd /var/www/html
    - git clone https://github.com/nextcloud/server.git --recursive --depth 1 -b stable20 nextcloud
    # temporary fix of autoloader.php
    - sed -i $'s|if (substr($fullPath, 0, strlen($root) + 1) === $root . \'/\')|if (is_string($root) and substr($fullPath, 0, strlen($root) + 1) === $root . \'/\')|g' nextcloud/lib/autoloader.php
    - chown -R www-data:www-data nextcloud && pushd nextcloud/apps && mv /tmp/gpxpod ./
    - sudo -u www-data php /var/www/html/nextcloud/occ maintenance:install --database "mysql" --database-name oc_autotest --database-user oc_autotest --database-pass="" --admin-user "admin" --admin-pass "password"
    - sudo -u www-data php /var/www/html/nextcloud/occ app:enable gpxpod
    - sudo -u www-data php /var/www/html/nextcloud/occ maintenance:mode --off
    # check code with occ
    - sudo -u www-data php /var/www/html/nextcloud/occ app:check-code gpxpod
    # check JS code
    - jshint --verbose gpxpod/js/gpxpod.js && echo "jshint OK" || echo "jshint has complaints"
    - popd ; popd ; mkdir coverage
    - phpunit --configuration /var/www/html/nextcloud/apps/gpxpod/phpunit.xml


pages:
  stage: deploy
  dependencies:
    - test_nc_sqlite
  before_script:
    - echo 'nothing to install for pages jobs'
  only:
    refs:
      - master
  artifacts:
    paths:
      - public
  script:
    - sleep 5
    - mkdir public
    - mv coverage public/

build_nightly:
  stage: build
  only:
    refs:
      - build
  artifacts:
    paths:
      - gpxpod-nightly.tar.gz
  script:
    - npm install -g npm
    - make
    - version=nightly make appstore
    - mv /tmp/build/gpxpod-nightly.tar.gz ./
